#ifndef _VECTOR_H
#define _VECTOR_H
#include "array_m.h"

/* name for vector files (groundstate, startvec, excitation, temp) */
#define FileGS   "tmp/d%d.vec"
#define FileSV   "tmp/s%d.vec"
#define FileEX   "tmp/d%de.vec"
#define FileTM   "tmp/t%d.vec"
#define FileEV   "tmp/ev%d.vec"

#ifdef NoSnprintf
/* some systems do not know more secure sprintf-version */
#define snprintf(a,b,c,d) sprintf(a,c,d)
#endif

double copy_av(scplx *v1, double r, scplx *v0);  /* v1=r*v0, [return norm(v1)] */
double add_av(scplx *v1, double r, scplx *v0);  /* v1+=r*v0, return norm(v1) */
void   mltply_av(double r, scplx *v0);  /* v0*=r */
void   clrvec(scplx *v);
void   touchvec(scplx *v); /* 2015-03-08 parallel touching mem pages */
double normvec(scplx *v);

/* if blk==-1 save all blocks, idx>=0 index for name="d%d.vec" */
int savevec( scplx *v,const char *nam,int idx,int blk);
int loadvec( scplx *v,const char *nam,int idx,int blk);
int loadvec2(scplx *v,const char *nam, int idx);  /* lade vec von textfile */
   
void randvec(scplx *v, int method, int rng_ini); /* 2016-04-15 add method */
cplx sprod(scplx *a, scplx *b); /* Skalarprodukt REIHENFOLGE!!!! */
int  iortho(scplx *v0, scplx *v1); /* 0=ok,1=parallel */

#endif
