/*
 measure available memory on a cluster of nodes (per node base) == memeater
 
 often some bad daemons tend to eat user memory,
  so big jobs can fail to alloc enough memory
  
 INSTALL:  mpicc -O2 -o memavail memavail.c
 RUN:      mpirun -np <tasks> ./memavail
           SLURM_TASK_MEM=300 srun -N 1-9999 --task-mem=300 ./memavail
           mpicc memavail.c && SLURM_TASK_MEM=300 srun -N 12 ./a.out # ulimit
           # task-mem=300 (malloc=218MB,ulimit.vmem=300MB)
           # task-mem=600 (malloc=518MB,ulimit.vmem=600MB)
           # memleak.slurmd: ssh root@sca-m0n0 /etc/init.d/slurmd restart 
sample:
 # malloc2: sumMB=    38784 nodeMB=   3154 -   3248 diff%=   2.89
 0 :  3235     0 418688 418076 412992 71168 2011 /usr/sbin/slurmd -f /opt/sicortex/config/slurm.conf.sca -c
 # malloc2: sumMB=    38870 nodeMB=   3184 -   3248 diff%=   1.97
 8 :  4220     0 142720 142108 137152 6528 2011 /usr/sbin/slurmd -f /opt/sicortex/config/slurm.conf.sca -c
 # malloc2: sumMB=    38874 nodeMB=   3188 -   3248 diff%=   1.85
 8 : 27091  6118  80320 82618 75392 5312 18:10 /.root0/local/home/j/./a.out
 8 : 27237  6118  80320 82618 75392 5312 18:39 /.root0/local/home/j/./a.out 0 0
 6 :  5186  6118  80320 82618 75392 5312 18:39 /.root0/local/home/j/./a.out 0 0
 9 :  6025  6118  80320 82618 75392 5312 18:39 /.root0/local/home/j/./a.out 0 0
 5 :  5206  6118  80320 82618 75392 5312 18:39 /.root0/local/home/j/./a.out 0 0
 3 :  5681  6118  80320 82618 75392 5312 18:39 /.root0/local/home/j/./a.out 0 0
   3: 3234     0  81280 80668 75712 6912  2011 /usr/sbin/slurmd -f /opt/sicortex/config/slurm.conf.sca -c
 11 : 3237     0 146816 146204 141248 6976 2011 /usr/sbin/slurmd -f /opt/sicortex/config/slurm.conf.sca -c
 7 :  3238     0 144768 144156 139200 6784 2011 /usr/sbin/slurmd -f /opt/sicortex/config/slurm.conf.sca -c
 4 :  3235     0 146880 146268 141312 6976 2011 /usr/sbin/slurmd -f /opt/sicortex/config/slurm.conf.sca -c
 1 :  3232     0 215552 214940 209856 7616 2011 /usr/sbin/slurmd -f /opt/sicortex/config/slurm.conf.sca -c
 2 :  3233     0 214400 213788 208832 7360 2011 /usr/sbin/slurmd -f /opt/sicortex/config/slurm.conf.sca -c
 0 : 28563     0 216704 216092 211008 8128 18:06 /usr/sbin/slurmd -f /opt/sicortex/config/slurm.conf.sca -c
 diff=6MB after slurmd restart (kills tasks only, use -t 0:5:0 !) 
 # 3.6GB nicht nutzbar! 3000MB=OK.2918 3100MB=ok.3018 3300MB=ok.3218 3500MB=killed
 #  m24n25 crashed without any message
 srun -p scx-comp -s -t 0:5:0 -N 1-30 --nice=-1000 -O --task-mem=3000 ./a.out 
 # check available distributed memory
 # mpi_n=23 size_t[B]=8 options: maxtest=0 trigger=400
 # malloc1: sumMB=    67114 nodeMB=   2918 -   2918 diff%=   0.00
 # malloc2: sumMB=    67114 nodeMB=   2918 -   2918 diff%=   0.00
 # access2:                node[s]=  8.937 -  9.132 diff%=   2.19
 # m1n7 m1n0 m0n17 gecrashed!? 
 srun -p big -s -t 0:15:0 -N 1-970 --nice=-1000 -O --task-mem=3200 ./a.out 
 # Problem: overcommit_ratio=100% + scfab-driver-malloc(bug)
   

strange behaviour:
 - CentOS-5.7 k2.6.18-274 cat /proc/sys/vm/overcommit_* # 2 100 free=1.5GB
 # check available distributed memory
 # mpi_n=1 size_t[B]=8 options: maxtest=0 trigger=400
 # malloc1: sumMB= 83887556 nodeMB= 83887556 - 83887556 diff%=   0.00
 # malloc2: sumMB= 83887556 nodeMB= 83887556 - 83887556 diff%=   0.00
 # = 83TB ??? sysctl.conf=22.6.2011 uptime=109d=3.6months=seitFeb12
 # -n 2 = 2*83TB (ca.48bit) 83887392 = 0x05000520 bit24+26 btw bit44+46
 #  + libc.malloc OR kernel problem? (try strace)
 # but using maxtest=2000 
 # mpi_n=2 size_t[B]=8 options: maxtest=2000 trigger=400
 # malloc1: sumMB=     2920 nodeMB=   1460 -   1460 0x000005b4 diff%=   0.00
 # malloc2: sumMB=     1462 nodeMB=      2 -   1460 0x000005b4 diff%=  99.86 
 #  + race condition problem !!! (able to kill ff during startup)
 # Signal: Segmentation fault (11)
 # Signal code: Address not mapped (1)
 # ok for one thread!
 #  solution? compare hostnames + pids? start with minTaskId per Node?
 #    
  
ChangeLog:
 2013-08-26 optimized for lowmem conditions
 2012-05-26 initial version

*/


#define _GNU_SOURCE 1 // this defines __USE_GNU in features.h for sched.h

#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#ifdef CFG_noMPI    // for the case of pure SMP and MPI is not available
#define MPI_Init(a,b) 1
#define MPI_SUCCESS 1
#define MPI_Comm_size(MPI_COMM_WORLD, mpi_n)
#define MPI_Comm_rank(MPI_COMM_WORLD, mpi_i)
#define MPI_Barrier(MPI_COMM_WORLD)
#define MPI_Wtime()  ((double)time(NULL))
#define MPI_Finalize()
#define MPI_Abort(MPI_COMM_WORLD,xx) exit(xx)
#else
#include <mpi.h>
#endif

int main(int argn, char *argv[]){
  long int sumMB, tmp1;
  int err;
  int t=2, i, j, mpi_n=1, mpi_i=0, bit;
  int chunksize= 1024*1024; // 1MB == 2^20
  int mallocMB= 0;   // maximum allocable memory
  int maxMB, minMB;  // maximum allocable memory (min)
  int maxtest= 0;    // 0 means no (maxint) limit of test
  int trigger=400;   // trigger diff to maxMB
  char *cmd=NULL;    // trigger extra command
  char *pp; // pointer 
  double t1, t2, tmin, tmax;
  if (MPI_Init(&argn, &argv) != MPI_SUCCESS) exit(1);
  MPI_Comm_size(MPI_COMM_WORLD, &mpi_n);
  MPI_Comm_rank(MPI_COMM_WORLD, &mpi_i);
  if (argn>1) maxtest=atoi(argv[1]); // max tested memory
  if (argn>2) trigger=atoi(argv[2]); // trigger diff to maxMB
  if (argn>3) cmd=argv[3];           // triggered command
  setvbuf(stdout, NULL, _IONBF, 0); /* dont buffer output, does not help on OOM */

  if (!mpi_i)
    printf("# check available distributed memory\n"
           "# mpi_n=%d size_t[B]=%d options: maxtest=%d trigger=%d\n",
           mpi_n, (int)sizeof(size_t), maxtest, trigger);
  if (cmd && !mpi_i) printf("# cmd= %s\n", cmd);

  // get s1=hostname s2=biggest_process for later output
  { FILE *f1; char s3[256];
    f1=popen("hostname;ps --sort=vsize h -A -w -o pid,uid,vsz,dsiz,size,rsz,"
             "stime,cmd|tail -1","r");
    s1[0]=0;fgets(s1,255,f1);
    s2[0]=0;fgets(s2,255,f1);
    while(!feof(f1)) {
      s3[0]=0; if(!fgets(s3,255,f1)) break;
    }
    pclose(f1);
  }
                                  
  pp=NULL;
  // ToDo sync for shared mem? barrier + 30*40us
  // ToDo: for 2++ tasks/node overbooking may possible, serialized malloc?
  for(bit=30;bit>0;bit--) {
    if (maxtest && (mallocMB|(1<<bit))>maxtest) continue; // skip
    pp= malloc( (mallocMB|(1<<bit)) * (size_t)chunksize );
    if (pp) mallocMB|=1<<bit;
    if (pp) free(pp);
  }
  // ToDo: if (mallocMB==(1<<31)-1) "warning_malloc=maxtestable"

  tmp1= mallocMB;
  MPI_Allreduce( &tmp1,     &sumMB, 1, MPI_LONG, MPI_SUM, MPI_COMM_WORLD);
  MPI_Allreduce( &mallocMB, &maxMB, 1, MPI_INT,  MPI_MAX, MPI_COMM_WORLD);
  MPI_Allreduce( &mallocMB, &minMB, 1, MPI_INT,  MPI_MIN, MPI_COMM_WORLD);
                                                     
  if (!mpi_i)
    printf("# malloc1: sumMB= %8ld nodeMB= %6d - %6d 0x%08x diff%%= %6.2f\n",
            sumMB, minMB, maxMB, maxMB, (maxMB-minMB)*100./(maxMB));

  // ToDo: sleep 1s (relaxing)
  sleep(1);
  
  // alloc for access test (may fail on 2nd try, reduce on failure)
  for (;;) { 
    pp= malloc( mallocMB * (size_t)chunksize );
    if (!pp) mallocMB--; // ToDo: should be notized
    if ( pp) break;
  }  
       
  tmp1= mallocMB;
  MPI_Allreduce( &tmp1,     &sumMB, 1, MPI_LONG, MPI_SUM, MPI_COMM_WORLD);
  MPI_Allreduce( &mallocMB, &maxMB, 1, MPI_INT,  MPI_MAX, MPI_COMM_WORLD);
  MPI_Allreduce( &mallocMB, &minMB, 1, MPI_INT,  MPI_MIN, MPI_COMM_WORLD);
                                                     
  if (!mpi_i)
    printf("# malloc2: sumMB= %8ld nodeMB= %6d - %6d 0x%08x diff%%= %6.2f\n",
             sumMB, minMB, maxMB, maxMB, (maxMB-minMB)*100./(maxMB));
  sleep(1);
//  exit(1);
  // ToDo: kmalloc no leaved? sum free from /proc/meminfo/ free+cached+buffered(reclaimable)
               
  t1=MPI_Wtime();
  // how to catch segfault or swapping (slowdown)!? time? fork/exec 
  for (i=0;i<mallocMB;i++)
    for (j=0;j<chunksize;j+=4096) // touch each mem page
       pp[i*(size_t)chunksize+j]=0;

  // better free here to avoid OOM-crashes
  // may cause task be killed and slurmd to hang (unknown preconditions)
  //  2012-06-02 ca 1:00 kautz to scx-m1n8 + scx-m24n25 (down)
  //    +5min m1n8 up, slurmd 370MB(Jan25) + 3* srun(May)
  //    +5min m24n25 no SSH, dead console
  // mkautz_overcommit=90%: sum=38934-38944 min=3214-3216 max=3250 (schwankt!)
  //  2/node: 
  // # malloc2: sumMB=    36124 nodeMB=      9 -   3228 diff%=  99.72
  // # access2:                node[s]=  9.908 - 10.276 diff%=   3.72
  // Segmentation fault
  t2=(MPI_Wtime()-t1)*maxMB / mallocMB; // compensate memDiff
  MPI_Allreduce( &t2, &tmax, 1, MPI_DOUBLE,  MPI_MAX, MPI_COMM_WORLD);
  MPI_Allreduce( &t2, &tmin, 1, MPI_DOUBLE,  MPI_MIN, MPI_COMM_WORLD);
  if (!mpi_i)
    printf("# access2:                node[s]= %6.3f - %6.3f diff%%= %6.2f\n",
          tmin, tmax, (tmax-tmin)*100./(tmin));

  free(pp); // better before MPIcalls to avoid OOM-crashes??? ToDo
// send hostnames + mallocMB + ps.maxProc to task0 (cost n*msg Bytes)         
//  int MPI_Gather ( void *sendbuf, int sendcnt, MPI_Datatype sendtype, 
//                  void *recvbuf, int recvcount, MPI_Datatype recvtype, 
//                                  int root, MPI_Comm comm )
// via MPI_Send-loop it costs minimum mem but more time
// popen("hostname;ps --sort=vsize h -A -w -o pid,uid,vsize,stime,cmd")
//  + fgets + pclose()
// ps --sort=vsize h -A -w -o pid,uid,vsz,dsiz,size,rsz,stime,cmd
// ToDo: gather ps-data, find outriders, sendback trigger
// ToDo: we may on lowmemcondition here (get hostname etc. at start, output here?
//  MPI_Barrier(MPI_COMM_WORLD);
  sleep(1); // give concurrent tasks on same node time to release
  /* ensure memory is back, segfaults on kautz 2tasks/node without Barrier */
  /* mem: ypbind=20352 sshd=12032 slurmd=8576 */
  if (maxMB-mallocMB>=trigger)
  {
    fputs(s1,stdout);  /* srun -l ... labels the output mem=82624 */
    fputs(s2,stdout);  /* srun -l ... labels the output mem=82624 */
    if (cmd) system(cmd); // cmd to clean memory (slurmd restart kills task)
  }

  MPI_Finalize();
  return 0;
}
